#!/usr/bin/python

# 2011-12-07 - code cleanup and auto-choose exam file based on period
# 2012-01-01 - added admin functionality
# 2013-06-05 - added special functionality (untested)

import cgi
import cgitb

cur = '3'
closed = True
allow_admin = False
allow_special = False

p3 = ( 'mitchell_441735' )

admins = ( 'mitchell_441735' )
special = { 'quiroz_845620': '8' }


p1 = ('barron_862828', 'briseno_835764', 'carroll_845089', 'chang_885289', 'daniel_862827', 'garcia_835576', 'greenstr_844142', 'guerra_863235', 'heath_839440', 'holliman_833118', 'kern_846044', 'lewis_879070', 'lusk_844068', 'mendoza_847295', 'naick_841328', 'preis_863591', 'raghunat_873864', 'richmond_896505', 'romanlop_838995', 'schaffne_842004', 'seng_837078', 'suryakus_878614', 'tatum_837428' )

p2 = ( 'batte_833725', 'berkel_839079', 'biggerst_868149', 'carrillo_831857', 'eaves_893454', 'ekas_841315', 'forney_849576', 'hall_857972', 'hansen_837776', 'hausam_840588', 'johnson_873877', 'malik_840754', 'manas_842065', 'martinez_840762', 'pergrim_890664', 'reiling_868181', 'roden_837402', 'saner_868932', 'smith_842364', 'stebbins_837349', 'steele_854711', 'walter_886617', 'williams_840858', 'womack_863877' )

p4 = ( 'abdala_887201', 'adrian_841858', 'aguilar_835060', 'alvarez_839142', 'ayalatel_861932', 'brun_837273', 'chang_886002', 'connors_857584', 'curylo_897652', 'elias_868385', 'garsson_884231', 'halsell_833494', 'jawed_892578', 'laughlin_846633', 'longoria_842207', 'mehta_845155', 'orona_842563', 'orr_840844', 'pratapa_856330', 'ramos_845156', 'villarre_833913', 'ross_844371', 'tuchenha_837797' )

p8 = ( 'aldred_870102', 'blauen_837388', 'burkhard_858787', 'cannon_837389', 'champion_837561', 'garcia_851433', 'gilly_847468', 'hale_887516', 'heerdink_863585', 'johnson_882034', 'lane_837604', 'mcdaniel_837733', 'parrish_873434', 'quiroz_845620', 'shorey_847450', 'smith_833533', 'song_854300', 'szabo_852737', 'traub_878725', 'vandewal_845562', 'warner_840556', 'white_867923' )

p5 = ( 'barth_855692', 'biarum_840215', 'brown_833732', 'carlton_855961', 'caward_853021', 'fairless_880031', 'gage_837706', 'hart_837775', 'johnston_834107', 'kelle_837368', 'lopez_832625', 'mcgehee_850247', 'muzy_837557', 'opotowsk_880460', 'pickerin_838129', 'plourde_831661', 'poche_837401', 'rogers_856554', 'schneide_856215', 'sillito_837748', 'teakell_873930' )

p7 = ( 'aleshire_866647', 'brown_833732', 'flores_878599', 'former_866738', 'gage_837706', 'garcia_835576', 'hazelwoo_858410', 'jakobovi_834818', 'lilly_834727', 'lopez_839264', 'malik_833868', 'neal_833874', 'oneil_837226', 'phelps_855185', 'plourde_831661', 'roberts_834604', 'smith_842364', 'springer_834256', 'tatum_837428', 'teakell_873930', 'walter_886611', 'warren_854937' )

logins_all = { '1': p1, '2': p2, '3': p3, '4': p4, '5': p5, '7': p7, '8': p8 }
logins = logins_all[cur]

exams_all = {
	'1': '/var/www/exam/cs1-spring-2012.html',
	'2': '/var/www/exam/cs1-spring-2012.html',
	'3': '/var/www/exam/cs1-spring-2012.html',
	'4': '/var/www/exam/cs1-spring-2012.html',
	'5': '/var/www/exam/cs2-spring-2011.html',
	'7': '/var/www/exam/web-midterm-2012.html',
	'8': '/var/www/exam/cs1-spring-2012.html',
}
examfile = exams_all[cur]

def error(s):
	print "<html><body><p>", s, "</p></body></html>"

def ordify( s ):
	i = int(s)
	ordinals = ( 'th', 'st', 'nd', 'rd', 'th', 'th', 'th', 'th', 'th' )
	ordinal = ordinals[i]
	return str(s) + ordinal

def content():
	global examfile
	if closed and not allow_admin:
		error("Sorry, no classes are testing at this time. Try again during your scheduled class period.")
		return

	form = cgi.FieldStorage()
	if 'login' not in form or 'mm' not in form or 'dd' not in form or 'yyyy' not in form:
		error("Error: login or birthday incorrect.")
		return

	mm = form.getfirst('mm','0')
	dd = form.getfirst('dd','0')
	yyyy = form.getfirst('yyyy','0')
	if mm == '0' or dd == '0' or yyyy == '0':
		error("Error: Login or birthday incorrect.")
		return

	Login = form.getfirst('login')
	login = Login.lower()

	admin_login = False
	if allow_admin and login in admins:
		if int(yyyy) - int(dd) != 1974:
			error("error: login or birthday incorrect")
			return
		else:
			admin_login = True
			examfile = exams_all[mm[1]]

	if closed and not admin_login:
		error("Sorry, no classes are testing at this time. Try again during your scheduled class period.")
		return

	if allow_special and login in special:
		period = special[login]
		examfile = exams_all[period]

	elif not admin_login and login not in logins:
		period = ordify(cur)
		error("<p>Only %s period is allowed to take the exam at this time, and I can't find '%s' in that period.</p>" % (period, Login) )
		return

	with open( examfile, 'r' ) as f:
		test = f.readlines()

	for i, line in enumerate(test):
		if line.startswith("#doit"):
			bday = yyyy + '-' + mm + '-' + dd
			out = '<input type="hidden" name="period" value="%s">\n' % cur
			out += '<input type="hidden" name="name" id=\'seed\' value="%s">\n' % login
			out += '<input type="hidden" name="bday" value="%s">\n' % bday
			if admin_login:
				out += '<input type="hidden" name="admin" value="True">\n'
				Login = 'Administrator'
			out += "<p>This test generated just for %s.</p>\n" % Login
			test[i] = out

	print "".join(test)


def main():
	print "Content-type: text/html\n"
	content()

cgitb.enable()
main()
